package	jp.co.sds_corp.fixconnect.transport;

import	java.util.List;
import	java.util.Map;
import	java.util.Vector;
import	java.util.concurrent.ConcurrentHashMap;

import	jp.co.sds_corp.fixconnect.message.FIXMessage;
import	jp.co.sds_corp.fixconnect.message.IMessageReceiver;
import	jp.co.sds_corp.fixconnect.message.MessageReceiveEvent;

public class ReceiverSupport
{
	List<IMessageReceiver>	listLsn = new Vector<IMessageReceiver>();
	Map<String,List<IMessageReceiver>> mapLsn =
		new ConcurrentHashMap<String,List<IMessageReceiver>>();

	public ReceiverSupport() {
	}

	public void addMessageReceiver( IMessageReceiver l ) {
		listLsn.add( l );
	}

	public boolean removeMessageReceiver( IMessageReceiver l ) {
		return listLsn.remove( l );
	}

	public void addMessageReceiver( String msgType, IMessageReceiver l ) {
		List<IMessageReceiver> list = mapLsn.get( msgType );
		if ( list == null ) {
			list = new Vector<IMessageReceiver>();
			mapLsn.put( msgType, list );
		}
		list.add( l );
	}

	public boolean removeMessageReceiver( String msgType, IMessageReceiver l ) {
		List<IMessageReceiver> list = mapLsn.get( msgType );
		if ( list == null ) {
			return false;
		}
		return list.remove( l );
	}

	public void fireMessageReceived( FIXMessage msg ) {
		MessageReceiveEvent ev = new MessageReceiveEvent( msg );
		fireMessageReceived( ev );
	}

	public void fireMessageReceived( FIXSession session, MessageReceiveEvent ev ) {
		ev.setSession( session );
		fireMessageReceived( ev );
	}

	public void fireMessageReceived( MessageReceiveEvent ev ) {
		for ( IMessageReceiver l : listLsn ) {
			l.onMessage( ev );
		}
		FIXMessage msg = ev.getMessage();
		String type = msg.getMsgType();
		List<IMessageReceiver> list = mapLsn.get( type );
		if ( list == null ) {
			return;
		}
		for ( IMessageReceiver l : list ) {
			l.onMessage( ev );
		}
	}

}
