package	jp.co.sds_corp.fixconnect.transport;

import	jp.co.sds_corp.fixconnect.FIXEvent;

/**
* セッションの状態が変化したことを表すイベントです。
*/
public class StateChangeEvent extends FIXEvent
{
	public StateChangeEvent( FIXSession session,
			SessionState oldState, SessionState newState )
	{
		this.session = session;
		this.oldState = oldState;
		this.newState = newState;
	}

	public String toString() {
		String ret = getClass().getName();
		ret += " session=[" + getSession() + "]";
		ret += " [" + getOldState() + "->" + getNewState() + "]";
		return ret;
	}

	FIXSession	session;	// FIXセッション情報
	SessionState	oldState;	// 変化前の状態
	SessionState	newState;	// 変化後の状態

	/**
	* FIXセッション情報を設定します。
	* @param	var		設定するデータ
	*/
	public void setSession( FIXSession var ) {
		this.session = var;
	}
	/**
	* FIXセッション情報を取得します。
	* @return	FIXセッション情報
	*/
	public FIXSession getSession() {
		return session;
	}

	/**
	* セッションの変化前の状態を設定します。
	* @param	var		設定するデータ
	*/
	public void setOldState( SessionState var ) {
		this.oldState = var;
	}
	/**
	* セッションの変化前の状態を取得します。
	* @return	セッションの変化前の状態
	*/
	public SessionState getOldState() {
		return oldState;
	}

	/**
	* セッションの変化後の状態を設定します。
	* @param	var		設定するデータ
	*/
	public void setNewState( SessionState var ) {
		this.newState = var;
	}
	/**
	* セッションの変化後の状態を取得します。
	* @return	セッションの変化後の状態
	*/
	public SessionState getNewState() {
		return newState;
	}

}
