package	jp.co.sds_corp.fixconnect.transport;

import	jp.co.sds_corp.fixconnect.FIXEvent;

/**
* Transportレイヤのイベントです。
*/
public class TransportEvent extends FIXEvent
{
	public enum Type {
		CONNECT, CLOSE, TIMEOUT, ACCEPT, ERROR
	}

	public TransportEvent( FIXSession session, Type type ) {
		this.session = session;
		this.socket = session.getSocket();
		this.type = type;
	}

	public TransportEvent( FIXSocket socket, Type type ) {
		this.socket = socket;
		this.type = type;
	}

	public String toString() {
		String ret = getClass().getName();
		ret += " " + getType();
		if ( getSession() != null ) {
			ret += " session=[" + getSession().toString() + "]";
		} else {
			ret += " socket=[" + getSocket() + "]";
		}
		return ret;
	}

	FIXSession	session;	// FIXセッション情報
	FIXSocket	socket;	// イベントの発生元
	Type	type;	// イベントタイプ

	/**
	* FIXセッション情報を設定します。
	* @param	var		設定するデータ
	*/
	public void setSession( FIXSession var ) {
		this.session = var;
	}
	/**
	* FIXセッション情報を取得します。
	* @return	FIXセッション情報
	*/
	public FIXSession getSession() {
		return session;
	}

	/**
	* イベントの発生元を設定します。
	* @param	var		設定するデータ
	*/
	public void setSocket( FIXSocket var ) {
		this.socket = var;
	}
	/**
	* イベントの発生元を取得します。
	* @return	イベントの発生元
	*/
	public FIXSocket getSocket() {
		return socket;
	}

	/**
	* イベントタイプを設定します。
	* @param	var		設定するデータ
	*/
	public void setType( Type var ) {
		this.type = var;
	}
	/**
	* イベントタイプを取得します。
	* @return	イベントタイプ
	*/
	public Type getType() {
		return type;
	}

}
