package jp.co.sds_corp.fixconnect.transport;

import jp.co.sds_corp.fixconnect.test.DummyServer;
import jp.co.sds_corp.test.BasicTestCase;
import jp.co.sds_corp.util.common.DumpTool;
import jp.co.sds_corp.util.config.DOMConfiguration;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

/**
 * Unit test for simple App.
 */
public class StressTest extends BasicTestCase
{
	static final CmnLogger logger = CmnLogFactory.getLogger();
	DumpTool dump = new DumpTool();
	DummyServer	server;
	StressRunner runner = new StressRunner();

	@Override
	public void setUp() throws Exception {
		super.setUp();

		DOMConfiguration doc = DOMConfiguration.findResource( "stress.xml" );

		IConfiguration config;
		config = doc.getChild( "Server" );
		setUpServer( config );

		runner.setUp();
	}

	void setUpServer( IConfiguration config ) throws Exception {
		server = new DummyServer();
		server.init( config );
		server.start();
	}

    /**
     */
    public void testSession() throws Exception {
		runner.testSession();
	}

	@Override
    public void tearDown() throws Exception {
		runner.tearDown();

		logger.debug( this, "stop server" );
		server.stop();
		super.tearDown();
    }

}
